import { EventEmitter } from '@angular/core';
import { DomSanitizer, SafeStyle } from '@angular/platform-browser';
import { AnimationEvent } from '@angular/animations';
import { Direction } from './direction';
import { Offset } from './offset';
import { Dimension } from './dimension';
import { SwingStackDirective } from './swing-stack.directive';
export declare class SwingCardComponent {
    private stack;
    private sanitizer;
    readonly __cardState: any;
    readonly _transform: SafeStyle;
    private _offset;
    private _rotation;
    private _lastMove;
    private _cardState;
    private _animationParams;
    private _rotationFactor;
    private _velocityFactor;
    readonly _directionX: Direction;
    readonly _directionY: Direction;
    readonly _offsetState: OffsetState;
    readonly cardState: CardState;
    readonly cardStateChange: EventEmitter<CardStateEvent>;
    readonly offsetStateChange: EventEmitter<OffsetStateEvent>;
    constructor(stack: SwingStackDirective, sanitizer: DomSanitizer);
    _panstart(event: any): void;
    _panmove(event: any): void;
    _panend(event: any): void;
    _move(event: any): void;
    _stateAnimationDone(event: AnimationEvent): void;
    throwIn(offset: Offset): void;
    throwOut(offset: Offset): void;
    getDimensions(): Dimension;
    getThrowOutRange(offset: Offset): number;
}
export declare enum CardState {
    throwIn = "throwIn",
    throwOut = "throwOut",
    free = "free"
}
export interface CardStateEvent {
    card?: SwingCardComponent;
    state: CardState;
}
export declare enum OffsetState {
    stable = "stable",
    moving = "moving"
}
export interface OffsetStateEvent {
    card?: SwingCardComponent;
    offsetState: OffsetState;
    cardState: CardState;
}
